



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>PBRT笔记(3)——KD树</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">PBRT笔记(3)——KD树</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 04:47:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>茎节点与叶子节点</h4>
<p>茎节点与叶子节点皆适用KdAccelNode来表示<br /><br />
注意：这里使用了匿名union</p>
<blockquote><p>union有个特性:内部类型共用一段内存，且大小为内部最大类型的大小。</p></blockquote>
<pre class="prettyprint linenums"><code>struct KdAccelNode {<br />
&lt;KdAccelNode Methods&gt;<br />
    union {<br />
        Float split; // Interior<br />
        int onePrimitive; // Leaf<br />
        int primitiveIndicesOffset; // Leaf<br />
    };<br />
    union {<br />
        int flags; // Both<br />
        int nPrims; // Leaf<br />
        int aboveChild; // Interior<br />
    };<br />
};<br />
</code></pre>
<p>使用8字节存储叶子节点（2个union各4byte），其中flags中的低二位2bit用于区分分割方向以及叶子节点，nPrims的高30位存储图元存储数。InitInterior函数也是差不多的操作。<br /><br />
primNums数组存储了图元容器的index，</p>
<pre class="prettyprint linenums"><code>void KdAccelNode::InitLeaf(int *primNums, int np,<br />
                           std::vector&lt;int&gt; *primitiveIndices) {<br />
    //标记为叶子<br />
    flags = 3;<br />
    //np为图元个数，这样做可以保证上一步flags=3时的存储的数据不会覆盖掉<br />
    nPrims |= (np &lt;&lt; 2);<br />
    //存储图元index，如果是0~1个，使用onePrimitive来存储<br />
    if (np == 0)<br />
        onePrimitive = 0;<br />
    else if (np == 1)<br />
        onePrimitive = primNums[0];<br />
    else {<br />
    //多个图元的情况下，使用存储index数组的偏移值，之后存储每个图元index<br />
        primitiveIndicesOffset = primitiveIndices-&gt;size();<br />
        for (int i = 0; i &lt; np; ++i) primitiveIndices-&gt;push_back(primNums[i]);<br />
    }<br />
}<br />
</code></pre>
<h4>构建树</h4>
<pre class="prettyprint linenums"><code>KdTreeAccel::KdTreeAccel(std::vector&lt;std::shared_ptr&lt;Primitive&gt;&gt; p,<br />
                         int isectCost, int traversalCost, Float emptyBonus,<br />
                         int maxPrims, int maxDepth)<br />
    : isectCost(isectCost),<br />
      traversalCost(traversalCost),<br />
      maxPrims(maxPrims),<br />
      emptyBonus(emptyBonus),<br />
      primitives(std::move(p)) {<br />
    //nextFreeNode为下一个可用节点的index，nAllocedNodes为分配空间的节点总数<br />
    //将两者设为0，可以让系统在初始化树中的第一个节点时分配内存而不是在启动就分配内存。<br />
    //这两个变量用于判断在此次递归中是否需要申请内存块<br />
    ProfilePhase _(Prof::AccelConstruction);<br />
    nextFreeNode = nAllocedNodes = 0;<br />
    //计算深度的经验公式:8 + 1.3 log(N)<br />
    if (maxDepth &lt;= 0)<br />
        maxDepth = std::round(8 + 1.3f * Log2Int(int64_t(primitives.size())));

    //计算kd树结构的边界盒，以及创建各图元边界盒数组<br />
    std::vector&lt;Bounds3f&gt; primBounds;<br />
    primBounds.reserve(primitives.size());<br />
    for (const std::shared_ptr&lt;Primitive&gt; &amp;prim : primitives) {<br />
        Bounds3f b = prim-&gt;WorldBound();<br />
        bounds = Union(bounds, b);<br />
        primBounds.push_back(b);<br />
    }

    //分配内存的相应变量

    //edges用于存储x，y，z三个方向上的所有可能切割图元位置<br />
    //因为边界盒有min、max值，所有这里的需要图元个数*2<br />
    std::unique_ptr&lt;BoundEdge[]&gt; edges[3];<br />
    for (int i = 0; i &lt; 3; ++i)<br />
        edges[i].reset(new BoundEdge[2 * primitives.size()]);<br />
    //以最坏打算确定prim1的空间<br />
    std::unique_ptr&lt;int[]&gt; prims0(new int[primitives.size()]);<br />
    std::unique_ptr&lt;int[]&gt; prims1(new int[(maxDepth + 1) * primitives.size()]);

    //primNums 为与当前节点重叠的图元index数组<br />
    std::unique_ptr&lt;int[]&gt; primNums(new int[primitives.size()]);<br />
    for (size_t i = 0; i &lt; primitives.size(); ++i) primNums[i] = i;

    //开始递归构建kd树<br />
    buildTree(0, bounds, primBounds, primNums.get(), primitives.size(),<br />
              maxDepth, edges, prims0.get(), prims1.get());<br />
}<br />
</code></pre>
<p>nodeNum为创建节点的偏移量（primNums中的index）</p>
<pre class="prettyprint linenums"><code>void KdTreeAccel::buildTree(int nodeNum, const Bounds3f &amp;nodeBounds,<br />
                            const std::vector&lt;Bounds3f&gt; &amp;allPrimBounds,<br />
                            int *primNums, int nPrimitives, int depth,<br />
                            const std::unique_ptr&lt;BoundEdge[]&gt; edges[3],<br />
                            int *prims0, int *prims1, int badRefines) {<br />
    CHECK_EQ(nodeNum, nextFreeNode);<br />
    //当分配的内存使用完时，分配下一块内存<br />
    if (nextFreeNode == nAllocedNodes) {<br />
        int nNewAllocNodes = std::max(2 * nAllocedNodes, 512);<br />
        KdAccelNode *n = AllocAligned&lt;KdAccelNode&gt;(nNewAllocNodes);<br />
        if (nAllocedNodes &gt; 0) {<br />
            memcpy(n, nodes, nAllocedNodes * sizeof(KdAccelNode));<br />
            FreeAligned(nodes);<br />
        }<br />
        nodes = n;<br />
        nAllocedNodes = nNewAllocNodes;<br />
    }<br />
    ++nextFreeNode;

    //当需要分割的图元数足够小或是树的深度达到一定次数则生成叶子节点停止递归<br />
    if (nPrimitives &lt;= maxPrims || depth == 0) {<br />
        nodes[nodeNum].InitLeaf(primNums, nPrimitives, &amp;primitiveIndices);<br />
        return;<br />
    }

    //茎节点需要通过分割来生成，这里采用了类似之前生成BVH的SAH算法

    int bestAxis = -1, bestOffset = -1;<br />
    Float bestCost = Infinity;<br />
    Float oldCost = isectCost * Float(nPrimitives);<br />
    Float totalSA = nodeBounds.SurfaceArea();<br />
    Float invTotalSA = 1 / totalSA;<br />
    Vector3f d = nodeBounds.pMax - nodeBounds.pMin;

    //选择一个用于分割图元的轴向<br />
    //优先选择具有最大空间性的轴向<br />
    int axis = nodeBounds.MaximumExtent();<br />
    int retries = 0;<br />
    //goto语句跳转用<br />
retrySplit:

    //初始化对应edges二维数组中对应轴的数组<br />
    //通过图元数找到对应的index，在通过index获得边界盒<br />
    for (int i = 0; i &lt; nPrimitives; ++i) {<br />
        int pn = primNums[i];<br />
        const Bounds3f &amp;bounds = allPrimBounds[pn];<br />
        edges[axis][2 * i] = BoundEdge(bounds.pMin[axis], pn, true);<br />
        edges[axis][2 * i + 1] = BoundEdge(bounds.pMax[axis], pn, false);<br />
    }

    //以切割位置为准进行升序排序，如果位置相同，以类型start为先<br />
    std::sort(&amp;edges[axis][0], &amp;edges[axis][2 * nPrimitives],<br />
              [](const BoundEdge &amp;e0, const BoundEdge &amp;e1) -&gt; bool {<br />
                  if (e0.t == e1.t)<br />
                      return (int)e0.type &lt; (int)e1.type;<br />
                  else<br />
                      return e0.t &lt; e1.t;<br />
              });

    //遍历所有分割位置来计算最佳分割点<br />
    int nBelow = 0, nAbove = nPrimitives;<br />
    for (int i = 0; i &lt; 2 * nPrimitives; ++i) {<br />
        if (edges[axis][i].type == EdgeType::End) --nAbove;<br />
        //取得分割位置<br />
        Float edgeT = edges[axis][i].t;<br />
        //判断当前分割点是否在节点的边界盒内<br />
        if (edgeT &gt; nodeBounds.pMin[axis] &amp;&amp; edgeT &lt; nodeBounds.pMax[axis]) {<br />
            // 取得另两个轴，用于计算分割后2个边界盒的面积，之后再用公式计算消耗<br />
            int otherAxis0 = (axis + 1) % 3, otherAxis1 = (axis + 2) % 3;<br />
            Float belowSA = 2 * (d[otherAxis0] * d[otherAxis1] +<br />
                                 (edgeT - nodeBounds.pMin[axis]) *<br />
                                     (d[otherAxis0] + d[otherAxis1]));<br />
            Float aboveSA = 2 * (d[otherAxis0] * d[otherAxis1] +<br />
                                 (nodeBounds.pMax[axis] - edgeT) *<br />
                                     (d[otherAxis0] + d[otherAxis1]));<br />
            Float pBelow = belowSA * invTotalSA;<br />
            Float pAbove = aboveSA * invTotalSA;<br />
            Float eb = (nAbove == 0 || nBelow == 0) ? emptyBonus : 0;<br />
            Float cost =<br />
                traversalCost +<br />
                isectCost * (1 - eb) * (pBelow * nBelow + pAbove * nAbove);

            //如果消耗比之前的变量小，则更新对应的变量<br />
            if (cost &lt; bestCost) {<br />
                bestCost = cost;<br />
                bestAxis = axis;<br />
                bestOffset = i;<br />
            }<br />
        }<br />
        if (edges[axis][i].type == EdgeType::Start) ++nBelow;<br />
    }<br />
    CHECK(nBelow == nPrimitives &amp;&amp; nAbove == 0);

    //如果没有找到最优切割位置，则切换轴向继续寻找<br />
    if (bestAxis == -1 &amp;&amp; retries &lt; 2) {<br />
        ++retries;<br />
        axis = (axis + 1) % 3;<br />
        goto retrySplit;<br />
    }<br />
    if (bestCost &gt; oldCost) ++badRefines;<br />
    //消耗大于一定数量 &amp;&amp; 图元数小于一定量 或者无法找到最优切割位置，则直接生成叶子节点，结束递归<br />
    //无法找到最优切割位置参考书295页的图，即所有图元都重叠在一起<br />
    //当然可能出现好几次循环也找不到最佳结果的情况，所以系统给予4次机会，让其继续寻找<br />
    if ((bestCost &gt; 4 * oldCost &amp;&amp; nPrimitives &lt; 16) || bestAxis == -1 ||<br />
        badRefines == 3) {<br />
        nodes[nodeNum].InitLeaf(primNums, nPrimitives, &amp;primitiveIndices);<br />
        return;<br />
    }

    //将分割的图元分组，用于下一次递归<br />
    int n0 = 0, n1 = 0;<br />
    for (int i = 0; i &lt; bestOffset; ++i)<br />
        if (edges[bestAxis][i].type == EdgeType::Start)<br />
            prims0[n0++] = edges[bestAxis][i].primNum;<br />
    for (int i = bestOffset + 1; i &lt; 2 * nPrimitives; ++i)<br />
        if (edges[bestAxis][i].type == EdgeType::End)<br />
            prims1[n1++] = edges[bestAxis][i].primNum;

    //进行下一次递归<br />
    Float tSplit = edges[bestAxis][bestOffset].t;<br />
    Bounds3f bounds0 = nodeBounds, bounds1 = nodeBounds;<br />
    //以切割位置为准，重新计算两个孩子节点的边界盒<br />
    bounds0.pMax[bestAxis] = bounds1.pMin[bestAxis] = tSplit;<br />
    buildTree(nodeNum + 1, bounds0, allPrimBounds, prims0, n0, depth - 1, edges,<br />
              prims0, prims1 + nPrimitives, badRefines);<br />
    int aboveChild = nextFreeNode;<br />
    nodes[nodeNum].InitInterior(bestAxis, aboveChild, tSplit);<br />
    buildTree(aboveChild, bounds1, allPrimBounds, prims1, n1, depth - 1, edges,<br />
              prims0, prims1 + nPrimitives, badRefines);<br />
}<br />
</code></pre>
<pre class="prettyprint linenums"><code><br />
bool KdTreeAccel::Intersect(const Ray &amp;ray, SurfaceInteraction *isect) const {<br />
    ProfilePhase p(Prof::AccelIntersect);<br />
    Float tMin, tMax;<br />
    if (!bounds.IntersectP(ray, &amp;tMin, &amp;tMax)) {<br />
        return false;<br />
    }

    Vector3f invDir(1 / ray.d.x, 1 / ray.d.y, 1 / ray.d.z);<br />
    PBRT_CONSTEXPR int maxTodo = 64;<br />
    //KdToDo记录尚未被处理的节点<br />
    KdToDo todo[maxTodo];<br />
    int todoPos = 0;<br />
    bool hit = false;<br />
    const KdAccelNode *node = &amp;nodes[0];<br />
    while (node != nullptr) {<br />
        if (ray.tMax &lt; tMin) break;<br />
        //如果不是叶子节点<br />
        if (!node-&gt;IsLeaf()) {

            //首先与茎节点的分割平面做相交测试，以此来确定光线与节点的相交顺序<br />
            int axis = node-&gt;SplitAxis();<br />
            //射线的对应分量上的t值<br />
            Float tPlane = (node-&gt;SplitPos() - ray.o[axis]) * invDir[axis];

            //判断先后顺序取得两个节点<br />
            const KdAccelNode *firstChild, *secondChild;<br />
            int belowFirst =<br />
                (ray.o[axis] &lt; node-&gt;SplitPos()) ||<br />
                (ray.o[axis] == node-&gt;SplitPos() &amp;&amp; ray.d[axis] &lt;= 0);<br />
            if (belowFirst) {<br />
                firstChild = node + 1;<br />
                secondChild = &amp;nodes[node-&gt;AboveChild()];<br />
            } else {<br />
                firstChild = &amp;nodes[node-&gt;AboveChild()];<br />
                secondChild = node + 1;<br />
            }

            //t大于max或者为负数代表了射线不会第二个节点相交<br />
            if (tPlane &gt; tMax || tPlane &lt;= 0)<br />
                node = firstChild;<br />
            //小于tmin不会与第一个节点相交<br />
            else if (tPlane &lt; tMin)<br />
                node = secondChild;<br />
            //两个节点都相交<br />
            else {<br />
                //将第二个节点放入处理队列<br />
                todo[todoPos].node = secondChild;<br />
                todo[todoPos].tMin = tPlane;<br />
                todo[todoPos].tMax = tMax;<br />
                ++todoPos;<br />
                node = firstChild;<br />
                tMax = tPlane;<br />
            }<br />
        } else {<br />
            //叶子节点则对内部图元进行相交测试<br />
            int nPrimitives = node-&gt;nPrimitives();<br />
            if (nPrimitives == 1) {<br />
                const std::shared_ptr&lt;Primitive&gt; &amp;p =<br />
                    primitives[node-&gt;onePrimitive];<br />
                // Check one primitive inside leaf node<br />
                if (p-&gt;Intersect(ray, isect)) hit = true;<br />
            } else {<br />
                for (int i = 0; i &lt; nPrimitives; ++i) {<br />
                    int index =<br />
                        primitiveIndices[node-&gt;primitiveIndicesOffset + i];<br />
                    const std::shared_ptr&lt;Primitive&gt; &amp;p = primitives[index];<br />
                    // Check one primitive inside leaf node<br />
                    if (p-&gt;Intersect(ray, isect)) hit = true;<br />
                }<br />
            }

            //更新下一次遍历区域的min与max值<br />
            if (todoPos &gt; 0) {<br />
                --todoPos;<br />
                node = todo[todoPos].node;<br />
                tMin = todo[todoPos].tMin;<br />
                tMax = todo[todoPos].tMax;<br />
            } else<br />
                break;<br />
        }<br />
    }<br />
    return hit;<br />
}<br />
</code></pre>
<h4>结尾</h4>
<p>综上所述，KD树的分割（每个轴遍历所有分割方案）与BVH（SAH）分割（每个轴12次分割）更加精确，这样是的KD树的求交效率要比BVH好，也导致了渲染时需要花费比BVH更多的时间在构建KD树上。同时KD树在求交时会计算与光线与分割面的相交位置是否在[min,max]中来判断是否需要与茎节点中的两个节点一一求交，以此来减少求交计算量。而BVH通过深度优先遍历树进行求交的。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q762k8e.html">JavaWeb&lowbar;day03&lowbar;员工信息添加修改删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qndjpx8.html">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【开篇】【持续更新中。。。】</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxozweq.html">hduoj 1285 确定比赛名次</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmvn279.html">highCharts 图表统计控件使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0wrz0q.html">apache 日志中记录代理IP以及真实客户端IP</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gepm7l8.html">spring-mvc &plus; shiro框架整合&lpar;sonne&lowbar;game网站开发04&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geg3pz8.html">iOS 微信消息拦截插件系列教程－附录（服务端成果展示）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjw74x8.html">立即表达式的多种写法与注意点以及in操作符的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z0r2n9.html">&commat;JoinColumn解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5nm77q.html">AIX查看系统版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd21zd9.html">支持异步同步的分布式CommandBus MSMQ实现 - 支持Session传递、多实例处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q252kzlq.html">Java并发程序设计（二）Java并行程序基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7emewj9.html">Eclipse配置Maven的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql15g4e9.html">mysql视图 新手的问答</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko7wvjq.html">css之层叠上下文和层叠顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jv6rg8.html">ASP&period;MVC 项目中使用 UEditor 文本编辑器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndwom28.html">ArcGIS Engine中如何获取Map中已经选择的要素呢（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96mkvmy8.html">php数组函数-array&lowbar;key&lowbar;exists&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndepg38.html">Java中的内存泄漏分析说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/qd5ny2x9.html">【Umezawa&amp;&num;39&semi;s Jitte】真正用起来svn来管理版本</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnj3w7j8.html">用django2&period;1开发公司官网（上）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpw2w59.html">Linux 配置vim编辑器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z421g9.html">linux basic ------ dd 和 cp 的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/9506np08.html">Maven 学习总结 （二） 之  生命周期与插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpwdd39.html">jQuery使用（十三）：工具方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kedo29.html">ACM-ICPC 2018 徐州赛区网络预赛 A Hard to prepare&lpar;递推&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzkx748.html">pip换源安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y5k2w8.html">LaTeX技巧561：LaTeX如何让每一章带有目录？</a>
			</li>
						<li><a href="https://www.batexi.com/a/8megzooq.html">&lbrack;物理学与PDEs&rsqb;第2章第2节 粘性流体力学方程组 2&period;2 应力张量</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzkr448.html">使用PHP中的ajax做登录页面、验证用户名是否可用、动态调用数据库</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
